// Fill out your copyright notice in the Description page of Project Settings.


#include "RenderTargetFunctions.h"
#include "Engine/TextureRenderTarget.h"

TArray<FColor> URenderTargetFunctions::ReadPixels(UTextureRenderTarget* InputTexture)
{

    TArray<FColor> PixelData;
    FRenderTarget* RenderTarget = InputTexture->GameThread_GetRenderTargetResource();
    RenderTarget->ReadPixels(PixelData);

	return PixelData;
}

UTexture2D* URenderTargetFunctions::DrawPixels(int32 SizeX, int32 SizeY, TArray<FColor> PixelData)
{
    UTexture2D* Texture = UTexture2D::CreateTransient(SizeX, SizeY, PF_B8G8R8A8);
    void* TextureData = Texture->PlatformData->Mips[0].BulkData.Lock(LOCK_READ_WRITE);
    const int32 TextureDataSize = PixelData.Num() * 4;
    FMemory::Memcpy(TextureData, PixelData.GetData(), TextureDataSize);
    Texture->PlatformData->Mips[0].BulkData.Unlock();
    // Apply Texture changes to GPU memory
    Texture->UpdateResource();
    return Texture;
}
